/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Telefones;
import com.tabajara.base.tables.records.TelefonesRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TelefonesDao extends AbstractVertxDAO<TelefonesRecord, com.tabajara.base.tables.pojos.Telefones, Integer, Future<List<com.tabajara.base.tables.pojos.Telefones>>, Future<com.tabajara.base.tables.pojos.Telefones>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<TelefonesRecord,com.tabajara.base.tables.pojos.Telefones,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public TelefonesDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Telefones.TELEFONES, com.tabajara.base.tables.pojos.Telefones.class, new JDBCClassicQueryExecutor<TelefonesRecord,com.tabajara.base.tables.pojos.Telefones,Integer>(com.tabajara.base.tables.pojos.Telefones.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Telefones object) {
        return object.getTelid();
    }

    /**
     * Find records that have <code>telnumero IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Telefones>> findManyByTelnumero(List<String> values) {
        return findManyByCondition(Telefones.TELEFONES.TELNUMERO.in(values));
    }

    /**
     * Find records that have <code>fkfunmatricula IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Telefones>> findManyByFkfunmatricula(List<String> values) {
        return findManyByCondition(Telefones.TELEFONES.FKFUNMATRICULA.in(values));
    }
}
